package errors.exception;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import net.sourceforge.stripes.action.ActionBean;
import net.sourceforge.stripes.action.ForwardResolution;
import net.sourceforge.stripes.action.RedirectResolution;
import net.sourceforge.stripes.action.Resolution;
import net.sourceforge.stripes.controller.StripesConstants;
import net.sourceforge.stripes.exception.AutoExceptionHandler;
import net.sourceforge.stripes.validation.LocalizableError;
import net.sourceforge.stripes.validation.SimpleError;

public class ThisApplicationExceptionHandler implements AutoExceptionHandler {
    protected Log log;

    public Resolution handle(TopApplicationException ex, HttpServletRequest request, HttpServletResponse response) {

        LogFactory.getLog(this.getClass()).debug(ex);

        ActionBean bean = (ActionBean)request.getAttribute(StripesConstants.REQ_ATTR_ACTION_BEAN);
        if (bean != null) {
            bean.getContext().getValidationErrors().addGlobalError(new LocalizableError(ex.getClass().getName(),
											ex.getLocalizedMessage()));
	    return bean.getContext().getSourcePageResolution();
        } else {
            request.setAttribute("exception", ex);
            return new ForwardResolution("/error.jsp");
        }

    }

    public Resolution handleCase2(Exception2 ex, HttpServletRequest request, HttpServletResponse response) {
 
        LogFactory.getLog(this.getClass()).debug(ex);
        
        ActionBean bean = (ActionBean) request.getAttribute(StripesConstants.REQ_ATTR_ACTION_BEAN);
        bean.getContext().getValidationErrors().addGlobalError(new LocalizableError("msg.error2Special"));
        return new ForwardResolution("/");
    }
}